/*Generated Structures by Arjay07*/
/*Uses*/
/*StructureJS 2.0*/
/*By Arjay07*/

var IO = java.io;
var File = IO.File;
var FileReader = IO.FileReader;
var BufferedReader = IO.BufferedReader;
var String = java.lang.String;
var StringBuilder = java.lang.StringBuilder;

function readFile(file){

var str;
var br = new BufferedReader(new FileReader(file));
var data = new StringBuilder();

while((str = br.readLine()) != null){

data.append(str);
data.append("\n");

}

return data.toString();

}

function Vertex(x, y, z){

this.x = x;
this.y = y;
this.z = z;

}

function Structure(file){

var structure = readFile(file);
var line = structure.split("\n");
var v = [];
var id = [];
var dmg = [];

for(var i = 0; i < line.length; i++){

var param = line[i].split(":");
var coord = param[0].split("~");
var block = param[1].split(";");
var x = parseInt(coord[0]);
var y = parseInt(coord[1]);
var z = parseInt(coord[2]);
var b = parseInt(block[0]);
var d = parseInt(block[1]);

v.push(new Vertex(x, y, z));
id.push(b);
dmg.push(d==null?0:d);

}

this.positions = v;
this.blockIds = id;
this.damages = dmg;

}

function setStructure(structure, x, y, z)
{

var s = structure.positions;
var id = structure.blockIds;
var d = structure.damages;

for(var i = 0; i < s.length; i++){

var p = s[i];
var bId = id[i];
var bDmg = d[i]; 

setTile(x+p.x, y+p.y, z+p.z, bId, bDmg);

}

}

//////////////////////////////////
/**********COPY TO HERE**********/
//////////////////////////////////

function getSurface(x, z){

var i = 0;

for(var y = 1; y <= 128; y++){

if(Level.getTile(x, y, z) == 0){

i = y;
break;

}

}

return i;

}

function random(min, max){

return Math.floor((Math.random()*max)+min);

}

var SDCARD = android.os.Environment.getExternalStorageDirectory();
var housefile = new File(SDCARD, "house.xtr");
var house2file = new File(SDCARD, "house2.xtr");
var wellfile = new File(SDCARD, "well.xtr");
var jtreefile = new File(SDCARD, "jungletree.xtr");
var lava1file = new File(SDCARD, "lava_pool1.xtr");
var lava2file = new File(SDCARD, "lava_pool2.xtr");
var lava3file = new File(SDCARD, "lava_pool3.xtr");
var tallgrassfile = new File(SDCARD, "tallgrass1.xtr");
var bushfile = new File(SDCARD, "bush.xtr");
var wierdtreefile = new File(SDCARD, "wierdtree.xtr");
var skinnytreefile = new File(SDCARD, "skinnytree.xtr");
var bigtreefile = new File(SDCARD, "bigtree.xtr");
var house = new Structure(housefile);
var house2 = new Structure(house2file);
var well = new Structure(wellfile);
var jtree = new Structure(jtreefile);
var lava1 = new Structure(lava1file);
var lava2 = new Structure(lava2file);
var lava3 = new Structure(lava3file);
var tallgrass = new Structure(tallgrassfile);
var bush = new Structure(bushfile);
var wierdtree = new Structure(wierdtreefile);
var skinnytree = new Structure(skinnytreefile);
var bigtree = new Structure(bigtreefile);

function spawnStructures(){

for(var i = 0; i <= 3; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(house, x, getSurface(x, z), z);

}

for(var i = 0; i <= 2; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(house2, x, getSurface(x, z), z);

}

for(var i = 0; i <= 3; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(well, x, getSurface(x, z)-3, z);

}

for(var i = 0; i <= 5; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(jtree, x, getSurface(x, z), z);

}

for(var i = 0; i <= 7; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(wierdtree, x, getSurface(x, z), z);

}

for(var i = 0; i <= 5; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(skinnytree, x, getSurface(x, z), z);

}

for(var i = 0; i <= 3; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(bigtree, x, getSurface(x, z), z);

}

for(var i = 0; i <= 6; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(lava1, x, getSurface(x, z) - 25, z);

}

for(var i = 0; i <= 6; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(lava2, x, getSurface(x, z) - 45, z);

}

for(var i = 0; i <= 6; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(lava3, x, getSurface(x, z) - 15, z);

}

for(var i = 0; i <= 75; i++){

var x = random(0, 256);
var z = random(0, 256);
var y = getSurface(x, y);

if(Level.getTile(x, y, z)-1 == 2){

setStructure(tallgrass, x, y+1, z);

}

}

for(var i = 0; i <= 50; i++){

var x = random(0, 256);
var z = random(0, 256);
var y = getSurface(x, y);

if(Level.getTile(x, y, z)-1 == 2){

setStructure(bush, x, y+2, z);

}

}

}

function newLevel(){

var spawned = new File(SDCARD + "/games/com.mojang/minecraftWorlds/" + Level.getWorldDir(), "spawned.txt");

if(!spawned.exists()){

spawnStructures();

try{

spawned.createNewFile();

}catch(e){

print(e);

}

}

}